> For the complete documentation index, see [llms.txt](https://docs.metacces.com/whitepaper/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.metacces.com/whitepaper/metacces-general/blockchain-layer-1/developers/smart-contracts/variable-cap-asset.md).

# Variable Cap Asset

### 1. Write the token smart contract

{% embed url="<https://github.com/OpenZeppelin/openzeppelin-contracts/blob/master/contracts/token/ERC20/ERC20.sol>" %}

{% hint style="info" %}
This contract is designed to be unopinionated, allowing developers to access the internal functions in ERC20 (such as \_mint) and expose them as external functions in the way they prefer. On the other hand, ERC20 Presets (such as ERC20PresetMinterPauser) are designed using opinionated patterns to provide developers with ready to use, deployable contracts.
{% endhint %}

#### Functions

* name()
* symbol()
* decimals()
* totalSupply()
* balanceOf(account)
* transfer(recipient, amount)
* allowance(owner, spender)
* approve(spender, amount)
* transferFrom(sender, recipient, amount)
* increaseAllowance(spender, addedValue)
* decreaseAllowance(spender, subtractedValue)
* \_transfer(sender, recipient, amount)
* \_mint(account, amount)
* \_burn(account, amount)
* \_approve(owner, spender, amount)
* \_setupDecimals(decimals\_)

### 2. Compile your code into bytecode

### 3. Deploy your Variable-cap Asset by sending your code in a transaction to the Enter network

### 4. Navigate to the explorer to check that your token has been created

### 5. **You can use the \_mint function to create additional units of the token**


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter:

```
GET https://docs.metacces.com/whitepaper/metacces-general/blockchain-layer-1/developers/smart-contracts/variable-cap-asset.md?ask=<question>
```

The question should be specific, self-contained, and written in natural language.
The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
